#include <stdio.h>

FILE *fp_in = NULL;
int nImgOffset = 0;
int ImgToPtr = 0;
unsigned char ImgBuf[0x5E][0xC];
unsigned char A;

int ImgRepeats;
unsigned char ImgRepeatChar;
unsigned char RepeatToken;
unsigned char RePosToken;

//char *ToText[4] = { "..", ".#", "#.", "##" };
char *ToText[4] = { ".", "#", "O", "W" };

//  S U B R O U T I N E 

void GetImageByte(void) { A=fgetc(fp_in); printf("Char=%02X\n", A); }

// End of function GetImageByte

//  S U B R O U T I N E 

void DoDecompress(void)
{
	unsigned char X, Y;

	ImgRepeats=0;
	GetImageByte();
	RepeatToken=A;
	printf("Repeat=%02X\n", RepeatToken);
	GetImageByte();
	RePosToken=A;
	printf("RePos=%02X\n", RePosToken);

	X=8;
loc_0_404E:
	Y=8;
loc_0_4050:
	ImgToPtr=(X*40)+((Y/4)*8);
loc_0_4063:
	if (ImgRepeats)
	{
		ImgRepeats--;
		A=ImgRepeatChar;
	}
	else
	{
		GetImageByte();
		if (A==RepeatToken)
		{
			GetImageByte();
			ImgRepeats=A+3;
			GetImageByte();
			ImgRepeatChar=A;
			goto loc_0_4063;
		}
		else if (A==RePosToken)
		{
			GetImageByte();
			X=A;
			GetImageByte();
			Y=A;
			if (Y==0xFF) return;
			goto loc_0_4050;
		}
	}
	printf("%04X=%02X (%d,%d)\n", ImgToPtr, A, X, Y);
	ImgBuf[X][Y/4] = A;
	X+=2;
	if (X<0x5E) goto loc_0_4050;
	X-=0x56;
	Y+=4;
	if (Y<0x30) goto loc_0_4050;
	if (++X<10) goto loc_0_404E;
	for (X=8; X<0x5E; X++) {
		printf("\t.BYTE");
		for (Y=2; Y<0xC; Y++) {
			printf("%c $%02X", (Y==2) ? ' ' : ',', ImgBuf[X][Y]);
		}
		printf("\n");
	}
	for (X=8; X<0x5E; X++) {
		for (Y=2; Y<0xC; Y++) {
			printf("%s", ToText[(ImgBuf[X][Y]/64)&3]);
			printf("%s", ToText[(ImgBuf[X][Y]/16)&3]);
			printf("%s", ToText[(ImgBuf[X][Y]/4)&3]);
			printf("%s", ToText[ImgBuf[X][Y]&3]);
		}
		printf("\n");
	}
}

// End of function DoDecompress

int main(int argc, char *argv[])
{
	if (argc == 2)
	{
		fp_in = fopen(argv[1],"rb");
		if (fp_in)
		{
			GetImageByte();
			ImgToPtr=A;
			GetImageByte();
			ImgToPtr+=A<<8;
			printf("Header=%04X\n", ImgToPtr);
				DoDecompress();
		}
	}
}
